namespace com.progsbase.no.inductive.libraries.Pseudorandom_v0_1_3{

using static System.Math;

public class LinearCongruentialGenerator{
	public double x;
	public double a;
	public double c;
	public double m;
}
public class PseudorandomGenerator{
	public LinearCongruentialGenerator lcg;
}
public class Pseudorandom{
	public static LinearCongruentialGenerator CreateLinearCongruentialGeneratorNumericalRecipes(double seed){
		return CreateLinearCongruentialGeneratorCustom(Pow(2d, 32d), 1664525d, 1013904223d, seed);
	}


	public static LinearCongruentialGenerator CreateLinearCongruentialGeneratorCustom(double modulus, double multiplier, double increment, double seed){
		LinearCongruentialGenerator lcg;

		lcg = new LinearCongruentialGenerator();
		lcg.m = modulus;
		lcg.a = multiplier;
		lcg.c = increment;
		lcg.x = seed;

		return lcg;
	}


	public static double LinearCongruentialGeneratorNextNumber(LinearCongruentialGenerator lcg){
		lcg.x = Floor((lcg.a*lcg.x + lcg.c)%lcg.m);
		return lcg.x/lcg.m;
	}


	public static PseudorandomGenerator CreatePseudorandomNumberGenerator(double seed){
		PseudorandomGenerator prg;

		prg = new PseudorandomGenerator();
		prg.lcg = CreateLinearCongruentialGeneratorNumericalRecipes(seed);

		return prg;
	}


	public static double PseudorandomNextNumber(PseudorandomGenerator prg){
		return LinearCongruentialGeneratorNextNumber(prg.lcg);
	}


	public static double PseudorandomNextInteger(PseudorandomGenerator prg, double n){
		return Floor(PseudorandomNextNumber(prg)*n);
	}


	public static double PseudorandomNextIntegerBetween(PseudorandomGenerator prg, double a, double b){
		return Ceiling(a) + Floor(PseudorandomNextNumber(prg)*(b - a));
	}


	public static void delete(System.Object objectx){
		// C# has garbage collection.
	}
}

}